#ifndef __RECONV_TEXT_STORE_H_INCLUDED__
#define __RECONV_TEXT_STORE_H_INCLUDED__
#include <olectl.h>
#include <msctf.h>
#include <msaatext.h>


//! ϊ⃊Xg擾p̃eLXgXgA
class ReconvTextStore : public ITextStoreACP
{
public:
	//! IuWFNg̐
	static HRESULT CreateInstance(ReconvTextStore*& o_text_store_cp);
	//! fXgN^
	virtual ~ReconvTextStore();

	//! hLg̃bNsBꍇ true, sꍇ false ԂB
	bool LockDocument(DWORD i_lock_flags);
	//! hLg̃bNBbNĂȂ󋵂ŌĂ΂ȂƁB
	bool UnlockDocument();
	//! hLgbNH
	bool IsLocked(DWORD i_lock_flags);
	//! ϊ⃊Xg擾ZbgB
	bool SetString(const wchar_t* i_string);

	//==========================================================================
	// IUnknown p郁\bh
	//==========================================================================
	
	//! QƃJEg̃CNg
	STDMETHOD_ (DWORD, AddRef)();
	//! QƃJEg̃fNgщ
	STDMETHOD_ (DWORD, Release)();
	//! C^[tFCX̖₢킹
	STDMETHOD (QueryInterface)(REFIID, LPVOID*);

	//==========================================================================
	// ITextStoreACP p郁\bh
	//==========================================================================
	
	//! VN̓o^sB
	STDMETHODIMP AdviseSink(
		REFIID			i_riid,
		IUnknown*		io_unknown_cp,
		DWORD				i_mask
	);
	//! VN̓o^B
	STDMETHODIMP UnadviseSink(
		IUnknown*		io_unknown_cp
	);
	//! hLgbNēo^ς݃VÑ\bhR[B
	STDMETHODIMP RequestLock(
		DWORD				i_lock_flags,
		HRESULT*		o_session_result_p
	);
	//! hLg̃Xe[^X擾B
	STDMETHODIMP GetStatus(
		TS_STATUS*	o_document_status_p
	);
	//! hLg̑I͈͂擾B
	STDMETHODIMP GetSelection(
		ULONG								i_index,
		ULONG								i_selection_buffer_length,
		TS_SELECTION_ACP*		o_selections,
		ULONG*							o_fetched_length_p
	);
	//! eLXg擾B
	STDMETHODIMP GetText(
		LONG					i_start_index,
		LONG					i_end_index,
		WCHAR*				o_plain_text,
		ULONG					i_plain_text_length,
		ULONG*				o_plain_text_length_p,
		TS_RUNINFO*		o_run_info_p,
		ULONG					i_run_info_length,
		ULONG*				o_run_info_length_p,
		LONG*					o_next_unread_char_pos_p
	);

	//! eLXg̃CT[g܂͑I͈͂̕ύX\₢킹B
	STDMETHODIMP QueryInsert(
		LONG		i_start_index,
		LONG		i_end_index,
		ULONG		i_length,
		LONG*		o_start_index_p,
		LONG*		o_end_index_p
	);

	//==========================================================================
	// ReconvTextStore ł͎Ȃ\bhBE_NOTIMPL ԂB 
	//==========================================================================

	STDMETHODIMP GetActiveView(
		TsViewCookie*
	);
	STDMETHODIMP SetSelection(
		ULONG, const TS_SELECTION_ACP*
	);
	STDMETHODIMP SetText(
		DWORD, LONG, LONG, const WCHAR*, ULONG, TS_TEXTCHANGE*
	);
	STDMETHODIMP GetFormattedText(
		LONG, LONG, IDataObject**
	);
	STDMETHODIMP RequestSupportedAttrs(
		DWORD, ULONG, const TS_ATTRID*
	);
	STDMETHODIMP RequestAttrsAtPosition(
		LONG, ULONG, const TS_ATTRID*, DWORD
	);
	STDMETHODIMP RetrieveRequestedAttrs(
		ULONG, TS_ATTRVAL*, ULONG*
	);
	STDMETHODIMP GetEndACP(
		LONG*
	);
	STDMETHODIMP GetTextExt(
		TsViewCookie, LONG, LONG, RECT*, BOOL*
	);
	STDMETHODIMP GetScreenExt(
		TsViewCookie, RECT*
	);
	STDMETHODIMP GetWnd(
		TsViewCookie, HWND*
	);
	STDMETHODIMP InsertTextAtSelection(
		DWORD, const WCHAR*, ULONG, LONG*, LONG*, TS_TEXTCHANGE*
	);
	STDMETHODIMP RequestAttrsTransitioningAtPosition(
		LONG, ULONG, const TS_ATTRID*, DWORD
	);
	STDMETHODIMP FindNextAttrTransition(
		LONG, LONG, ULONG, const TS_ATTRID*, DWORD, LONG*, BOOL*, LONG*
	);
	STDMETHODIMP GetEmbedded(
		LONG, REFGUID, REFIID, IUnknown**
	);
	STDMETHODIMP QueryInsertEmbedded(
		const GUID*, const FORMATETC*, BOOL*
	);
	STDMETHODIMP InsertEmbedded(
		DWORD, LONG, LONG, IDataObject*, TS_TEXTCHANGE*
	);
	STDMETHODIMP GetACPFromPoint(
		TsViewCookie, const POINT*, DWORD, LONG*
	);
	STDMETHODIMP InsertEmbeddedAtSelection(
		DWORD, IDataObject*, LONG*, LONG*, TS_TEXTCHANGE*
	);

protected:
	//! RXgN^BCreateInstance() TuNX̂݌Ăяo\B
	ReconvTextStore();

private:
	//! Rs[RXgN^͎gp֎~ƂB
	ReconvTextStore(const ReconvTextStore&);
	//! Zq͎gp֎~ƂB
	const ReconvTextStore& operator=(const ReconvTextStore&);

	//==========================================================================
	// o
	//==========================================================================
protected:
	ULONG								m_ref_count;		//!< QƃJEg
	wchar_t							m_text[128];		//!< ϊ̊i[̈
	ITextStoreACPSink*	m_sink_cp;			//!< AdviseSink() œo^ꂽVN
	DWORD								m_sink_mask;		//!< AdviseSink() ɓnꂽ}XN
	volatile LONG				m_lock_count;		//!< bNJEg
	volatile DWORD			m_lock_flags;		//!< bÑ^Cv(RW)
};


#endif	// #ifndef __RECONV_TEXT_STORE_H_INCLUDED__
