#include "stdafx.h"
#include <INITGUID.h>
#include "TsfReconverter.h"


//=============================================================================


//! RXgN^
TsfReconverter::TsfReconverter()
:	m_thread_mgr_cp(NULL),
	m_document_mgr_cp(NULL),
	m_context_cp(NULL),
	m_function_provider_cp(NULL),
	m_reconversion_cp(NULL),
	m_text_store_cp(NULL),
	m_edit_cookie(0)
{
	HRESULT		hr = E_FAIL;
	
	do
	{
		// Xbh}l[W[̐
		hr = CoCreateInstance(
					 CLSID_TF_ThreadMgr,
					 NULL,
					 CLSCTX_INPROC_SERVER,
					 IID_ITfThreadMgr,
					 (void**)&m_thread_mgr_cp
				 );
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN,
						 "Xbh}l[W[̐Ɏs܂BG[R[h:0x%08X\n", hr
						);
			break;
		}
		
		// hLg}l[W[̐
		hr = m_thread_mgr_cp->CreateDocumentMgr(&m_document_mgr_cp);
		if( FAILED(hr) || m_document_mgr_cp == NULL )
		{
			_RPTF1(_CRT_WARN,
						 "hLg}l[W[̐Ɏs܂BG[R[h:0x%08X\n", hr
						);
			break;
		}
		
		// Xbh}l[W[̃ANeBu
		TfClientId	client_id = 0;
		hr = m_thread_mgr_cp->Activate(&client_id);
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN,
						 "Xbh}l[W[̃ANeBuɎs܂BG[R[h:0x%08X\n", hr
						);
			break;
		}
		
		// eLXgXgA̐
		ReconvTextStore::CreateInstance(m_text_store_cp);
		
		// ReLXg̐
		hr = m_document_mgr_cp->CreateContext(
					 client_id,
					 0,			// reserved
					 (ITextStoreACP*)m_text_store_cp,
					 &m_context_cp,
					 &m_edit_cookie
				 );
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN,
						 "ReLXg̐Ɏs܂BG[R[h:0x%08X\n", hr
						);
			break;
		}
		
		// ReLXg push
		hr = m_document_mgr_cp->Push(m_context_cp);
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN,
						 "ReLXg push Ɏs܂BG[R[h:0x%08X\n", hr
						);
			break;
		}
		
		// t@NVvoC_[擾B
		hr = m_thread_mgr_cp->GetFunctionProvider(
					 GUID_SYSTEM_FUNCTIONPROVIDER,
					 &m_function_provider_cp
				 );
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN,
						 "t@NVvoC_[̎擾Ɏs܂BG[R[h:0x%08X\n", hr
						);
			break;
		}

		// ITfFnReconversion ̎擾
		hr = m_function_provider_cp->GetFunction(
					 GUID_NULL,
					 IID_ITfFnReconversion,
					 (IUnknown**)&m_reconversion_cp
				 );
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN, "ITfFnReconversion ̎擾Ɏs܂BG[R[h : 0x%08X.\n", hr);
			break;
		}
		
		// tH[JX擾
		hr = m_thread_mgr_cp->SetFocus(m_document_mgr_cp);
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN,
						 "Xbh}l[W[ SetFocus() Ɏs܂BG[R[h:0x%08X\n", hr
						);
			break;
		}

		hr = S_OK;
	}
	while( 0 );
	
	if( FAILED(hr) )
		Cleanup();
	SetLastError(hr);
}


//=============================================================================


//! fXgN^
TsfReconverter::~TsfReconverter()
{
	Cleanup();
}


//=============================================================================


//! N[Abv
bool TsfReconverter::Cleanup()
{
	// eLXgXgẢ
	RELEASE(m_text_store_cp);
	// Ro[Wt@NV̉
	RELEASE(m_reconversion_cp);
	// t@NVvoC_[̉
	RELEASE(m_function_provider_cp);
	// ReLXg̉
	RELEASE(m_context_cp);
	// hLg}l[W[̉
	if( m_document_mgr_cp )
	{
		// SẴReLXgB
		m_document_mgr_cp->Pop(TF_POPF_ALL);
		RELEASE(m_document_mgr_cp);
	}
	// Xbh}l[W[̉
	if( m_thread_mgr_cp )
	{
		// fANeBuɂĂB
		m_thread_mgr_cp->Deactivate();
		RELEASE(m_thread_mgr_cp);
	}
	
	return true;
}


//=============================================================================


//! ɐǂׂB
bool TsfReconverter::IsOpened()
{
	return m_thread_mgr_cp != NULL;
}


//=============================================================================


//! tH[JX̎擾
bool TsfReconverter::SetFocus()
{
	bool		retval = false;
	
	if( IsOpened() )
	{
		// tH[JX
		HRESULT hr = m_thread_mgr_cp->SetFocus(m_document_mgr_cp);
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN,
						 "Xbh}l[W[ SetFocus() Ɏs܂BG[R[h:0x%08X\n", hr
						);
		}
		else
		{
			retval = true;
		}
	}
	
	return retval;
}


//=============================================================================


//! ϊ⃊Xg񋓂B
bool TsfReconverter::EnumCandidates(
	const wchar_t*						i_yomi,
	EnumCandidatesCallbackP		i_callback,
	void*											io_param
)
{
	bool								retval					= false;
	HRESULT							hr							= E_FAIL;
	TF_SELECTION				selections[10]	= { 0 };
	ULONG								fetched_count		= 0;
	ITfRange*						range_cp				= NULL;
	BOOL								is_converted		= FALSE;
	ITfCandidateList*		cand_list_cp		= NULL;
	ULONG								cand_length			= 0;
	
	do
	{
		if( IsOpened() == false )
		{
			_RPTF0(_CRT_WARN, "Ɏŝ EnumCandidates() Ă΂܂B\n");
			break;
		}
	
		// Zbg
		m_text_store_cp->SetString(i_yomi);
		
		// hLg̃bNsB
		if( m_text_store_cp->LockDocument(TS_LF_READ) )
		{
			// I͈͂̎擾
			hr = m_context_cp->GetSelection(
						 m_edit_cookie,
						 TF_DEFAULT_SELECTION,
						 numberof(selections),
						 selections,
						 &fetched_count
					 );
			
			// hLg̃AbN
			m_text_store_cp->UnlockDocument();
			
			if( FAILED(hr) )
			{
				_RPTF1(_CRT_WARN, "I͈͂̎擾Ɏs܂BG[R[h : 0x%08X.\n", hr);
				break;
			}
		}
		
		// ῗ͈擾B
		hr = m_reconversion_cp->QueryRange(selections[0].range, &range_cp, &is_converted);
		if( FAILED(hr) || range_cp == NULL )
		{
			_RPTF1(_CRT_WARN, "ῗ͈̎擾Ɏs܂BG[R[h : 0x%08X.\n", hr);
			break;
		}

		// ĕϊs
		hr = m_reconversion_cp->GetReconversion(selections[0].range, &cand_list_cp);
		if( FAILED(hr) || cand_list_cp == NULL )
		{
			_RPTF1(_CRT_WARN, "ĕϊɎs܂BG[R[h : 0x%08X.\n", hr);
			break;
		}
		
		// ␔擾B
		hr = cand_list_cp->GetCandidateNum(&cand_length);
		if( FAILED(hr) )
		{
			_RPTF1(_CRT_WARN, "␔̎擾Ɏs܂BG[R[h : 0x%08X.\n", hr);
			break;
		}
		
		// ߂lɃZbgB
		for(ULONG i = 0; i < cand_length; i++)
		{
			ITfCandidateString*		string_cp = NULL;
			BSTR									bstr			= NULL;

			if( SUCCEEDED(cand_list_cp->GetCandidate(i, &string_cp))
			&&	SUCCEEDED(string_cp->GetString(&bstr)) )
			{
				if( i_callback(i, cand_length, bstr, io_param) == false )
					i = cand_length;

				SysFreeString(bstr);
			}
			
			RELEASE(string_cp);
		}
		
		retval = true;
	}
	while( 0 );
	
	// N[Abv
	RELEASE(cand_list_cp);
	RELEASE(range_cp);
	for(int i = 0; i < numberof(selections); i++)
	{
		RELEASE(selections[i].range);
	}
	
	return retval;
}


//=============================================================================



