#ifndef __TSF_RECONVERTER_H_INCLUDED__
#define __TSF_RECONVERTER_H_INCLUDED__
#include <msctf.h>
#include <msaatext.h>
#include <ctffunc.h>
#include "ReconvTextStore.h"


//! TsfReconverter::EnumCandidates() ɓnR[obN֐
/*!
 *	@param[in]			i_index
 *		Ԗڂ̌₩B
 *	@param[in]			i_number_of_candidates
 *		̃g[^
 *	@param[in]			i_candidate
 *		╶BR[obN甲當͉B
 *	@param[in,out]	io_param
 *		EnumCandidates() ɓnp[^[B
 *
 *	@return 񋓂𑱂ꍇ true, ~ꍇ false ԂB
 */
typedef bool (*EnumCandidatesCallbackP)(int							i_index,
																				int							i_number_of_candidates,
																				const wchar_t*	i_candidate,
																				void*						io_param
																			 );


//! TSF(Text Service Framework) 𗘗pĕϊ⃊Xg擾NXB
class TsfReconverter
{
	//===========================================================================
	// J\bh
	//===========================================================================
public:
	//! RXgN^
	TsfReconverter();
	//! fXgN^
	virtual ~TsfReconverter();
	
	//! N[Abv
	bool Cleanup();
	
	//! ɐǂׂB
	bool IsOpened();
	
	//! tH[JX̎擾B
	bool SetFocus();

	//! ϊ⃊Xg񋓂B
	bool EnumCandidates(
		const wchar_t*						i_yomi,
		EnumCandidatesCallbackP		i_callback,
		void*											io_param
	);
	
	//===========================================================================
	// J\bh
	//===========================================================================
private:

	//! Rs[RXgN^͎gp֎~
	TsfReconverter(const TsfReconverter&);
	//! Zq͎gp֎~
	const TsfReconverter& operator=(const TsfReconverter&);

	//===========================================================================
	// o
	//===========================================================================
public:
	ITfThreadMgr*					m_thread_mgr_cp;
	ITfDocumentMgr*				m_document_mgr_cp;
	ITfContext*						m_context_cp;
	ITfFunctionProvider*	m_function_provider_cp;
	ReconvTextStore*			m_text_store_cp;
	ITfFnReconversion*		m_reconversion_cp;
	TfEditCookie					m_edit_cookie;
};


#endif
